diff -uNrd ircd-hybrid-7.0/doc/example.conf anynet-3.0/doc/example.conf
--- ircd-hybrid-7.0/doc/example.conf	Sat May 31 03:30:25 2003
+++ anynet-3.0/doc/example.conf	Wed Feb  4 13:08:44 2004
@@ -33,27 +33,21 @@
  * Sizes and times may be singular or plural.  
  */ 
 
-/* EFNET NOTE:
- * 
- * This config file is NOT suitable for EFNet.  EFNet admins should use
- * example.efnet.conf
- */
- 
  /* serverinfo {}:  Contains information about the server. (OLD M:) */
 serverinfo {
 	/* name: the name of our server */
-	name = "hades.arpa";
+	name = "anynet.server.example";
 
 	/* description: the description of our server.  '[' and ']' may not
 	 * be used here for compatibility with older servers.
 	 */
-	description = "hybrid-7 test server";
+	description = "anynet test server";
 
 	/* network info: the name and description of the network this server
 	 * is on.  Shown in the 005 reply and used with serverhiding.
 	 */
-	network_name = "MyNet";
-	network_desc = "This is My Network";
+	network_name = "Anynet";
+	network_desc = "Anynet IRC Network";
 
 	/* hub: allow this server to act as a hub and have multiple servers
 	 * connected to it.  This may not be changed if there are active
@@ -85,14 +79,27 @@
 	 *	chmod 0600 rsa.key
 	 *	chmod 0644 rsa.pub
 	 */
-	#rsa_private_key_file = "/usr/local/ircd/etc/rsa.key";
+	#rsa_private_key_file = "etc/rsa.key";
+
+	/* ssl_cert_file: the path to the file containing the SSL
+	 * certificate chain to be used for SSL client support (both the
+	 * certificate and the private key must be set for SSL to work.
+	 */
+	#ssl_cert_file = "etc/ssl-cert.pem";
+	
+	/* ssl_private_key_file: the path to the file containing the SSL
+	 * private key associated with the certificate above.
+	 */
+	#ssl_private_key_file = "etc/ssl-key.pem";
 };
 
-/* admin {}: contains admin information about the server. (OLD A:) */
+/* admin {}: contains admin information about the server. (OLD A:)
+ * These lines are displayed to the user in the order shown here. 
+ */
 admin {
-	name = "Smurf target";
-	description = "Main Server Administrator";
-	email = "<syn@packets.r.us>";
+	name = "Server Administrator Smith";
+	description = "Primary administrator";
+	email = "<admin@smith.example>";
 };
 
 /* logging {}: contains information about logfiles. */
@@ -116,10 +123,10 @@
 	ping_time = 2 minutes;
 
 	/* number per ip: the number of users per host allowed to connect */
-	number_per_ip = 2;
+	number_per_ip = 4;
 
 	/* max number: the maximum number of users allowed in this class */
-	max_number = 100;
+	max_number = 450;
 
 	/* sendq: the amount of data allowed in a clients queue before
 	 * they are dropped.
@@ -131,7 +138,7 @@
 	name = "restricted";
 	ping_time = 1 minute 30 seconds;
 	number_per_ip = 1;
-	max_number = 100;
+	max_number = 25;
 	sendq = 60kb;
 };
 
@@ -150,31 +157,39 @@
 	/* connectfreq: only used in server classes.  specifies the delay
 	 * between autoconnecting to servers.
 	 */
-	connectfreq = 5 minutes;
+	connectfreq = 1 minute;
 
 	/* max number: the amount of servers to autoconnect to */
 	max_number = 1;
 
 	/* sendq: servers need a higher sendq as they send more data */
-	sendq=2 megabytes;
+	sendq = 1 megabyte;
 };
 
 /* listen {}: contain information about the ports ircd listens on (OLD P:) */
 listen {
 	/* port: the specific port to listen on.  if no host is specified
-	 * before, it will listen on all available IPs.
+	 * before, it will listen on all available IPs.  Adding the
+	 * 'ssl' parameter after the ports will make that port (range)
+	 * listen for SSL connections.
 	 *
 	 * ports are seperated via a comma, a range may be specified using ".."
 	 */
 	
+	/* Anynet uses port 8888 for peering */
+	port = 8888;
+	
 	/* port: listen on all available IPs, ports 6665 to 6669 */
 	port = 6665 .. 6669;
 
+	/* listen for ssl on port 9999 */
+	#port = 9999 ssl;
+
 	/* host: set a specific IP/host the ports after the line will listen 
 	 * on.  This may be ipv4 or ipv6.
 	 */
 	host = "1.2.3.4";
-	port = 7000, 7001;
+	port = 7001, 7002;
 
 	host = "3ffe:1234:a:b:c::d";
         port = 7002;
@@ -237,7 +252,7 @@
 	#restricted = yes;
 
 	/* have ident: require the user has identd to connect (OLD I: + flag) */
-	have_ident = yes;
+	have_ident = no;
 };
 
 /* operator {}: defines ircd operators. (OLD O:)
@@ -246,7 +261,7 @@
  */
 operator {
 	/* name: the name of the oper */
-	name = "god";
+	name = "jebsu";
 
 	/* user: the user@host required for this operator.  CIDR is not
 	 * supported.  multiple user="" lines are supported.
@@ -263,7 +278,7 @@
 	 * A password should not be defined when this is used, see 
 	 * doc/challenge.txt for more information.
 	 */
-	#rsa_public_key_file = "/usr/local/ircd/etc/oper.pub";
+	#rsa_public_key_file = "etc/oper.pub";
 
 	/* class: the class the oper joins when they successfully /oper */
 	class = "opers";
@@ -282,8 +297,9 @@
 	 * rehash:       allows oper to REHASH config      (OLD 'H' flag)
 	 * die:          allows DIE and RESTART            (OLD 'D' flag)
 	 * admin:        gives admin privileges.  admins
-	 *               may (un)load modules and see the
-	 *               real IPs of servers.
+	 *               may (un)load modules, see the
+	 *               real IPs of servers, see +i users, and
+	 *               who's in secret channels (including ops in +a.)
 	 */
 	global_kill = yes;
 	remote = yes;
@@ -318,7 +334,7 @@
 	encrypted = no;
 
 	/* port: the port to connect to this server on */
-	port = 6666;
+	port = 8888;
 
 	/* hub mask: the mask of servers that this server may hub. Multiple
 	 * entries are permitted
@@ -355,7 +371,7 @@
 connect {
 	name = "encrypted.auth.example";
 	host = "some.host.somewhere";
-	port = 6667;
+	port = 8888;
 
 	/* cryptlink: enable full encryption for all data passing between our
 	 * server and this link and rsa authentication.
@@ -405,17 +421,23 @@
 };
 
 /* shared {}: users that are allowed to remote kline (OLD U:) */
+/*
+ * shared blocks also define non-hub servers that are allowed to set
+ * G-lines.  Hubs are always allowed to set G-lines because they need
+ * to be able to propogate them.  G-lines from non-shared leaves are
+ * dropped, and a warning is issued.
+ */
 shared {
 	/* name: the server the user must be on to set klines.  If this is not
 	 * specified, the user will be allowed to kline from all servers.
 	 */
-	name = "irc2.some.server";
+	name = "services.anynet.org";
 
 	/* user: the user@host mask that is allowed to set klines.  If this is
 	 * not specified, all users on the server above will be allowed to set
 	 * a remote kline.
 	 */
-	user = "oper@my.host.is.spoofed";
+	#user = "na@for.glines";
 };
 
 /* kill {}: users that are not allowed to connect (OLD K:)
@@ -440,19 +462,19 @@
 };
 
 /* resv {}: nicks and channels users may not use/join (OLD Q:) */
-resv {
-        /* reason: the reason for the proceeding resv's */
-        reason = "There are no services on this network";
-
-	/* resv: the nicks and channels users may not join/use */
-	nick = "nickserv";
-	nick = "chanserv";
-	channel = "#services";
-
-	/* resv: wildcard masks are also supported in nicks only */
-	reason = "Clone bots";
-	nick = "clone*";
-};
+#resv {
+#        /* reason: the reason for the proceeding resv's */
+#        reason = "There are no services on this network";
+#
+#	/* resv: the nicks and channels users may not join/use */
+#	nick = "nickserv";
+#	nick = "chanserv";
+#	channel = "#services";
+#
+#	/* resv: wildcard masks are also supported in nicks only */
+#	reason = "Clone bots";
+#	nick = "clone*";
+#};
 
 /* gecos {}:  The X: replacement, used for banning users based on their
  * "realname".  The action may be either:
@@ -475,7 +497,7 @@
 gecos {
 	name = "*http*";
 	reason = "Spambot";
-	action = silent;
+	action = warn;
 };
 
 /* The channel block contains options pertaining to channels */
@@ -503,7 +525,7 @@
 	 * or deopped by sending mode changes.  This can cause a flood and
 	 * could potentially be abused.
 	 */
-	use_anonops = no;
+	use_anonops = yes;
 
         /* vchans: permit virtual channels, multiple copies of the same
 	 * channel name.  read doc/vchans.txt for more details
@@ -513,7 +535,7 @@
         use_vchans = yes;
 
 	/* vchans oper only: only allow opers to create vchans via /cjoin */
-	vchans_oper_only = yes;
+	vchans_oper_only = no;
 
 	/* knock: Allows users to request an invite to a channel that
 	 * is locked somehow (+ikl).  If the channel is +p or you are banned
@@ -538,7 +560,7 @@
         quiet_on_ban = yes;
 
         /* max bans: maximum number of +b/e/I modes in a channel */
-        max_bans = 25;
+        max_bans = 30;
 
         /* splitcode: the ircd will check every 60s as to whether splitmode
 	 * should be disabled or not, so there may be a delay between a
@@ -632,7 +654,7 @@
 	 * without a '.' in them.  this will add one to the end.  only needed
 	 * for older servers.
 	 */
-        dot_in_ip6_addr = yes;
+        dot_in_ip6_addr = no;
         
         /* min nonwildcard: the minimum non wildcard characters in k/d/g lines
 	 * placed via the server.  klines hand placed are exempt from limits.
@@ -653,16 +675,16 @@
         /* anti spam time: the minimum time a user must be connected before
 	 * custom quit messages are allowed.
 	 */
-        anti_spam_exit_message_time = 5 minutes;
+        anti_spam_exit_message_time = 1 minute;
 
 	/* ts delta: the time delta allowed between server clocks before
 	 * a warning is given, or before the link is dropped.  all servers
 	 * should run ntpdate/rdate to keep clocks in sync
 	 */
-	ts_warn_delta = 30 seconds;
-	ts_max_delta = 5 minutes;
+	ts_warn_delta = 15 seconds;
+	ts_max_delta = 90 seconds;
 
-	/* client exit: prepend a users quit message with "Client exit: " */
+	/* client exit: add quotes around user-supplied quote messages */
 	client_exit = yes;
 
 	/* kline reason: show the user the reason why they are k/d/glined 
@@ -685,7 +707,7 @@
 	warn_no_nline = yes;
 
 	/* stats o oper only: make stats o (opers) oper only */
-	stats_o_oper_only=yes;
+	stats_o_oper_only=no;
 
 	/* stats P oper only: make stats P (ports) oper only */
 	stats_P_oper_only=no;
@@ -702,7 +724,7 @@
 	 *     masked: show users first matching auth block
 	 *     no:     show users all auth blocks.
 	 */
-	stats_k_oper_only=masked;
+	stats_k_oper_only=no;
                                     
 	/* caller id wait: time between notifying a +g user that somebody
 	 * is messaging them.
@@ -717,7 +739,7 @@
 	/* pace wait: time between more intensive commands
 	 * (ADMIN, INFO, LIST, LUSERS, MOTD, STATS, VERSION)
 	 */
-	pace_wait = 10 seconds;
+	pace_wait = 2 seconds;
 
 	/* short motd: send clients a notice telling them to read the motd
 	 * instead of forcing a motd to clients who may simply ignore it.
@@ -740,9 +762,6 @@
 	/* glines: enable glines, network wide temp klines */
 	glines = yes;
 
-	/* gline time: the amount of time a gline will remain before exiring */
-	gline_time = 1 day;
-
 	/* idletime: the maximum amount of time a user may idle before
 	 * they are disconnected
 	 */
@@ -766,7 +785,7 @@
 	/* max targets: the maximum amount of targets in a single 
 	 * PRIVMSG/NOTICE.  set to 999 NOT 0 for unlimited.
 	 */
-	max_targets = 4;
+	max_targets = 8;
 
 	/* client flood: maximum number of lines in a clients queue before
 	 * they are dropped for flooding.
@@ -787,7 +806,7 @@
 	 * Use "custom" for the (in)famous Hybrid custom messages.
 	 * Use "standard" for the compiled in defaults.
 	 */
-	message_locale = "custom";
+	message_locale = "standard";
 
 	/* usermodes configurable: a list of usermodes for the options below
 	 *
@@ -806,23 +825,24 @@
 	 * +u - unauth     - See unauthorized client notices
 	 * +w - wallop     - See server generated WALLOPS
 	 * +x - external   - See remote server connection and split notices
-	 * +y - spy        - See LINKS, STATS, TRACE notices etc.
+	 * +y - spy        - See LINKS, STATS, TRACE notices etc. (if enabled)
 	 * +z - operwall   - See oper generated WALLOPS
 	 */
 	 
 	/* oper only umodes: usermodes only opers may set */
-	oper_only_umodes = bots, cconn, debug, full, skill, nchange, 
-                     rej, spy, external, operwall, locops, unauth;
+	oper_only_umodes = bots, cconn, debug, full, nchange, 
+                     rej, spy, operwall, locops, unauth;
 
 	/* oper umodes: default usermodes opers get when they /oper */
-	oper_umodes = locops, servnotice, operwall, wallop;
+	oper_umodes = full, skill, locops, servnotice, operwall, wallop,
+		external;
 
 	/* servlink path: path to 'servlink' program used by ircd to handle
 	 * encrypted/compressed server <-> server links.
 	 *
 	 * only define if servlink is not in same directory as ircd itself.
 	 */
-	#servlink_path = "/usr/local/ircd/bin/servlink";
+	#servlink_path = "bin/servlink";
 
 	/* default cipher: default cipher to use for cryptlink when none is
 	 * specified in connect block.
@@ -854,15 +874,15 @@
 	 * Offers protection against flooders who reconnect quickly.  
 	 * Set to 0 to disable.
 	 */
-	throttle_time = 10;
+	throttle_time = 0;
 };
 
 modules {
 	/* module path: paths to search for modules specified below and 
 	 * in /modload.
 	 */
-	path = "/usr/local/ircd/modules";
-	path = "/usr/local/ircd/modules/autoload";
+	path = "modules";
+	path = "modules/autoload";
 
 	/* module: the name of a module to load on startup/rehash */
 	#module = "some_module.so";
diff -uNrd ircd-hybrid-7.0/doc/ircd.motd anynet-3.0/doc/ircd.motd
--- ircd-hybrid-7.0/doc/ircd.motd	Tue Dec 12 16:46:59 2000
+++ anynet-3.0/doc/ircd.motd	Wed Feb  4 01:33:10 2004
@@ -1 +1,2 @@
-This is ircd-hybrid MOTD replace it with something better
+Please replace this message of the day with something better.
+
diff -uNrd ircd-hybrid-7.0/help/opers/umode anynet-3.0/help/opers/umode
--- ircd-hybrid-7.0/help/opers/umode	Tue Nov 20 20:41:05 2001
+++ anynet-3.0/help/opers/umode	Wed Feb  4 01:48:24 2004
@@ -16,7 +16,7 @@
        * +r     - Can see 'rejected' client notices.
        * +k     - Can see server kill messages.
        * +f     - Can see 'I-line is full' notices.
-       * +y     - Can see stats/links/admin requests to name a few.
+       * +y     - Can see stats/links/admin requests (if enabled).
        * +d     - Can see server debug messages.
        * +n     - Can see client nick changes.
        * +x     - Can see new server introduction and split messages.
diff -uNrd ircd-hybrid-7.0/include/channel.h anynet-3.0/include/channel.h
--- ircd-hybrid-7.0/include/channel.h	Fri Jan 31 18:00:25 2003
+++ anynet-3.0/include/channel.h	Mon Feb  2 03:04:34 2004
@@ -119,8 +119,9 @@
 #endif
 extern int     is_voiced (struct Channel *chptr,struct Client *who);
 
-#define find_user_link(list,who) who!=NULL?dlinkFind(list,who):NULL
-#define FIND_AND_DELETE(list,who) who!=NULL?dlinkFindDelete(list,who)
+/* rain - added parenthesis to these two macros */
+#define find_user_link(list,who) (who!=NULL?dlinkFind(list,who):NULL)
+#define FIND_AND_DELETE(list,who) (who!=NULL?dlinkFindDelete(list,who))
 
 extern void    add_user_to_channel(struct Channel *chptr,
 				   struct Client *who, int flags);
@@ -154,7 +155,8 @@
 
 #define HoldChannel(x)          (!(x))
 /* channel visible */
-#define ShowChannel(v,c)        (PubChannel(c) || IsMember((v),(c)))
+/* rain - channels are always visible to admins */
+#define ShowChannel(v,c)        (PubChannel(c) || IsMember((v),(c)) || IsAdmin(v))
 
 #define IsMember(who, chan) ((who && who->user && \
                 dlinkFind(&who->user->channel, chan)) ? 1 : 0)
diff -uNrd ircd-hybrid-7.0/include/client.h anynet-3.0/include/client.h
--- ircd-hybrid-7.0/include/client.h	Sun Feb 16 17:54:35 2003
+++ anynet-3.0/include/client.h	Mon Feb  2 01:31:03 2004
@@ -36,6 +36,7 @@
 #include "linebuf.h"
 #include "channel.h"
 #include "res.h"
+
 #ifdef IPV6
 #define HOSTIPLEN	53 /* sizeof("ffff:ffff:ffff:ffff:ffff:ffff:255.255.255.255.ipv6") */
 #else
@@ -190,7 +191,7 @@
  * is on.
  */
 
-  dlink_list      vchan_map;
+  dlink_list        vchan_map;
 
 
   /* caller ID allow list */
@@ -200,9 +201,7 @@
   dlink_list	allow_list;	/* clients I'll allow to talk to me */
   dlink_list	on_allow_list;	/* clients that have =me= on their allow list*/
   
-  
   struct LocalUser *localClient;
-
 };
 
 struct LocalUser
@@ -312,6 +311,11 @@
   time_t last_knock;    /* time of last knock */
   unsigned long random_ping;
 
+  /* rain - for SSL client support */
+#ifdef SSL_CLIENT_SUPPORT
+  SSL              *ssl;
+  sslc_state       ssl_state;
+#endif
 };
 
 /*
@@ -340,6 +344,9 @@
 
 #define IsOper(x)		((x)->umodes & FLAGS_OPER)
 #define IsAdmin(x)		((x)->umodes & FLAGS_ADMIN)
+/* rain - added IsService and IsSSL */
+#define IsService(x)		((x)->umodes & FLAGS_SERVICE)
+#define IsSSL(x)		((x)->umodes & FLAGS_SSL)
 
 #define SetConnecting(x)        {(x)->status = STAT_CONNECTING; \
 				 (x)->handler = UNREGISTERED_HANDLER; }
@@ -422,6 +429,9 @@
 /* user information flags, only settable by remote mode or local oper */
 #define FLAGS_OPER         0x20000 /* Operator */
 #define FLAGS_ADMIN        0x40000 /* Admin on server */
+/* rain - added FLAGS_SERVICE and FLAGS_SSL */
+#define FLAGS_SERVICE	   0x80000 /* Service */
+#define FLAGS_SSL          0x100000 /* SSL connection */
 
 #define FLAGS_ALL	   FLAGS_SERVNOTICE
 
@@ -459,8 +469,9 @@
 #define FLAGS2_FLOODDONE        0x200000      /* Flood grace period has
                                                * been ended. */
 
+/* rain - added FLAGS_SERVICE and FLAGS_SSL to SEND_UMODES */
 #define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | \
-                      FLAGS_ADMIN)
+                      FLAGS_ADMIN | FLAGS_SERVICE | FLAGS_SSL)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                       FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
                       FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
@@ -615,8 +626,9 @@
                                   struct Client*, const char*);
 
 
-extern void     count_local_client_memory(int *count, int *memory);
-extern void     count_remote_client_memory(int *count, int *memory);
+/* rain - made memory argument types u_long and removed param names */
+extern void     count_local_client_memory(int *, u_long *);
+extern void     count_remote_client_memory(int *, u_long *);
 
 extern struct Client* find_chasing (struct Client *, char *, int *);
 extern struct Client* find_person (char *);
diff -uNrd ircd-hybrid-7.0/include/defaults.h anynet-3.0/include/defaults.h
--- ircd-hybrid-7.0/include/defaults.h	Sat Nov 23 12:12:55 2002
+++ anynet-3.0/include/defaults.h	Tue Jan 27 17:54:27 2004
@@ -42,18 +42,21 @@
 
 /* class {} default values */
 #define DEFAULT_SENDQ 9000000           /* default max SendQ */
-#define PORTNUM 6667                    /* default outgoing portnum */
+/* rain - made default port 8888 from 6667 */
+#define PORTNUM 8888                    /* default outgoing portnum */
 #define DEFAULT_PINGFREQUENCY    120    /* Default ping frequency */
 #define DEFAULT_CONNECTFREQUENCY 600    /* Default connect frequency */
 
+/* rain - made the min warning 5s and the default max/warn 30/10 seconds */
 #define TS_MAX_DELTA_MIN      10        /* min value for ts_max_delta */
-#define TS_MAX_DELTA_DEFAULT  600       /* default for ts_max_delta */
-#define TS_WARN_DELTA_MIN     10        /* min value for ts_warn_delta */
-#define TS_WARN_DELTA_DEFAULT 30        /* default for ts_warn_delta */
+#define TS_MAX_DELTA_DEFAULT  45        /* default for ts_max_delta */
+#define TS_WARN_DELTA_MIN     5         /* min value for ts_warn_delta */
+#define TS_WARN_DELTA_DEFAULT 10        /* default for ts_warn_delta */
 
 /* ServerInfo default values */
-#define NETWORK_NAME_DEFAULT "EFnet"             /* default for network_name */
-#define NETWORK_DESC_DEFAULT "Eris Free Network" /* default for network_desc */
+/* rain - changed these defaults for anynet */
+#define NETWORK_NAME_DEFAULT "Anynet"             /* default for network_name */
+#define NETWORK_DESC_DEFAULT "Anynet IRC Network" /* default for network_desc */
 
 /* General defaults */
 #define MAXIMUM_LINKS_DEFAULT 1         /* default for maximum_links */
@@ -62,7 +65,8 @@
 #define CLIENT_FLOOD_MAX     2000
 #define CLIENT_FLOOD_MIN     10
 
-#define LINKS_DELAY_DEFAULT  300
+/* rain - unused */
+/* #define LINKS_DELAY_DEFAULT  300 */
 
 #define MAX_TARGETS_DEFAULT 4           /* default for max_targets */
 
diff -uNrd ircd-hybrid-7.0/include/event.h anynet-3.0/include/event.h
--- ircd-hybrid-7.0/include/event.h	Fri Sep 20 01:31:54 2002
+++ anynet-3.0/include/event.h	Mon Feb  2 00:47:26 2004
@@ -25,6 +25,9 @@
 #ifndef INCLUDED_event_h
 #define INCLUDED_event_h
 
+/* rain - for prototype below */
+struct Client;
+
 /*
  * How many event entries we need to allocate at a time in the block
  * allocator. 16 should be plenty at a time.
diff -uNrd ircd-hybrid-7.0/include/hash.h anynet-3.0/include/hash.h
--- ircd-hybrid-7.0/include/hash.h	Fri May 24 19:34:07 2002
+++ anynet-3.0/include/hash.h	Mon Feb  2 04:04:13 2004
@@ -30,21 +30,36 @@
  *
  * used in hash.c, s_debug.c
  */
+#ifndef SMALL_NET
 #define U_MAX 65536
+#else
+/* rain - added smaller hash size for SMALL_NET */
+#define U_MAX 256
+#endif
 
 /* 
  * Channel hash table size
  *
  * used in hash.c, s_debug.c
  */
+#ifndef SMALL_NET
 #define CH_MAX 16384
+#else
+/* rain - added smaller hash size for SMALL_NET */
+#define CH_MAX 128
+#endif
 
 /*
  * RESV hash table size
  *
  * used in hash.c
  */
+#ifndef SMALL_NET
 #define R_MAX 1024
+#else
+/* rain - added smaller hash size for SMALL_NET */
+#define R_MAX 16
+#endif
 
 struct Client;
 struct Channel;
diff -uNrd ircd-hybrid-7.0/include/ircdauth.h anynet-3.0/include/ircdauth.h
--- ircd-hybrid-7.0/include/ircdauth.h	Sat Jan  5 04:14:28 2002
+++ anynet-3.0/include/ircdauth.h	Thu Jan 22 14:11:28 2004
@@ -51,7 +51,11 @@
 int ConnectToIAuth();
 void IAuthQuery(struct Client *client);
 extern void BeginAuthorization(struct Client *);
+#ifdef __GNUC__ /* rain - __attribute__ to catch nasties */
+extern void SendIAuth(char *, ...) __attribute__((format(printf, 1, 2)));
+#else
 extern void SendIAuth(char *, ...);
+#endif
 
 
 /*
diff -uNrd ircd-hybrid-7.0/include/isupport.h anynet-3.0/include/isupport.h
--- ircd-hybrid-7.0/include/isupport.h	Wed Dec 31 19:00:00 1969
+++ anynet-3.0/include/isupport.h	Mon Feb  2 01:37:12 2004
@@ -0,0 +1,33 @@
+#ifndef INCLUDED_isupport_h
+#define INCLUDED_isupport_h
+
+#define ISUPPORT_STANDARD	"draft-brocklesby-03"
+
+#define MAX_ISUPPORT_LINES	3
+
+#define ISUP_FLAG_EXCEPTS	0x00000001
+#define ISUP_FLAG_INVEX		0x00000002
+#define ISUP_FLAG_VCHANS	0x00000004
+#define ISUP_FLAG_KNOCK		0x00000008
+#define ISUP_FLAG_NOLOCAL	0x00000010
+#define ISUP_FLAG_STARTTLS	0x00000020
+
+#define ISUP_NO_PROPAGATE	(void *)0
+#define ISUP_PROPAGATE		(void *)1
+
+struct isupport_s {
+	char line[MAX_ISUPPORT_LINES][BUFSIZE];
+	int lines;
+	int changed_lines;
+	int old_flags;
+	int old_maxchans;
+	int old_maxbans;
+	int old_maxtargets;
+	char *old_netname;
+};
+
+extern void isupport_init(void);
+extern void isupport_deinit(void);
+extern void isupport_send(struct Client *);
+
+#endif
diff -uNrd ircd-hybrid-7.0/include/linebuf.h anynet-3.0/include/linebuf.h
--- ircd-hybrid-7.0/include/linebuf.h	Sun Jul 14 16:15:38 2002
+++ anynet-3.0/include/linebuf.h	Mon Feb  2 01:39:05 2004
@@ -75,9 +75,16 @@
 extern void linebuf_donebuf(buf_head_t *);
 extern int linebuf_parse(buf_head_t *, char *, int, int);
 extern int linebuf_get(buf_head_t *, char *, int, int, int);
+#ifdef __GNUC__ /* rain - __attribute__ format to catch nasties */
+extern void linebuf_putmsg(buf_head_t *, const char *, va_list *,
+                           const char *, ...)
+                           __attribute__((format(printf, 4, 5)));
+#else
 extern void linebuf_putmsg(buf_head_t *, const char *, va_list *,
                            const char *, ...);
-extern int linebuf_flush(int, buf_head_t *);
+#endif
+/* rain - added data parameter to linebuf_flush for SSL client support */
+extern int linebuf_flush(int, buf_head_t *, void *);
 extern void linebuf_attach(buf_head_t *, buf_head_t *);
 extern void count_linebuf_memory(int *, u_long *);
 #endif
diff -uNrd ircd-hybrid-7.0/include/list.h anynet-3.0/include/list.h
--- ircd-hybrid-7.0/include/list.h	Thu Jul 11 20:43:20 2002
+++ anynet-3.0/include/list.h	Mon Feb  2 00:55:03 2004
@@ -35,8 +35,9 @@
 struct Ban;
 
 extern void initUser(void);
-extern void count_user_memory(int *count,int *user_memory_used);
-extern void count_links_memory(int *count,int *links_memory_used);
+/* rain - made memory_used arguments u_longs and removed parameter names */
+extern void count_user_memory(int *, u_long *);
+extern void count_links_memory(int *, u_long *);
 extern void outofmemory(void);
 extern void free_user (struct User *, struct Client *);
 extern dlink_node *make_dlink_node (void);
diff -uNrd ircd-hybrid-7.0/include/listener.h anynet-3.0/include/listener.h
--- ircd-hybrid-7.0/include/listener.h	Fri May 24 19:34:07 2002
+++ anynet-3.0/include/listener.h	Mon Feb  2 01:39:38 2004
@@ -45,9 +45,13 @@
   struct irc_inaddr addr;              /* virtual address or INADDR_ANY */
   struct DNSQuery   *dns_query;
   char             vhost[HOSTLEN + 1]; /* virtual name of listener */
+#ifdef SSL_CLIENT_SUPPORT /* rain - SSL client support */
+  int              is_ssl;             /* socket accepts SSL connections */
+#endif
 };
 
-extern void        add_listener(int port, const char* vaddr_ip);
+/* rain - added use_ssl parameter for SSL client support */
+extern void        add_listener(int port, const char* vaddr_ip, int use_ssl);
 extern void        close_listener(struct Listener* listener);
 extern void        close_listeners(void);
 extern const char* get_listener_name(const struct Listener* listener);
diff -uNrd ircd-hybrid-7.0/include/modules.h anynet-3.0/include/modules.h
--- ircd-hybrid-7.0/include/modules.h	Tue Nov 12 08:45:40 2002
+++ anynet-3.0/include/modules.h	Mon Feb  2 01:05:57 2004
@@ -27,7 +27,7 @@
 #include "config.h"
 #include "setup.h"
 #include "parse.h"
-
+#include "hook.h" /* rain - for hook_burst_channel */
 
 #if defined(HAVE_SHL_LOAD)
 #include <dl.h>
@@ -53,6 +53,14 @@
 	char path[MAXPATHLEN];
 };
 
+/* rain - predeclare dlfunc() if we don't have it */
+#if !defined(HAVE_SHL_LOAD) && !defined(HAVE_DLFUNC)
+typedef void (*__function_p)(void);
+
+__function_p
+dlfunc(void *myHandle, const char *functionName);
+#endif
+
 /* add a path */
 void mod_add_path(char *path);
 void mod_clear_paths(void);
@@ -97,6 +105,8 @@
 extern struct Message eob_msgtab;
 extern struct Message error_msgtab;
 extern struct Message gline_msgtab;
+/* rain - for new GLINE module */
+extern int gline_netburst(struct Client *);
 extern struct Message help_msgtab;
 extern struct Message info_msgtab;
 extern struct Message invite_msgtab;
@@ -154,6 +164,13 @@
 extern struct Message whowas_msgtab;
 extern struct Message get_msgtab;
 extern struct Message put_msgtab;
+/* rain - made these modules default */
+extern void tburst_init(void);
+extern struct Message map_msgtab;
+#ifdef SSL_CLIENT_SUPPORT
+/* rain - SSL client support */
+extern struct Message starttls_msgtab;
+#endif
 extern void load_all_modules(int check);
 
 #endif /* STATIC_MODULES */
diff -uNrd ircd-hybrid-7.0/include/numeric.h anynet-3.0/include/numeric.h
--- ircd-hybrid-7.0/include/numeric.h	Wed Nov 27 10:46:24 2002
+++ anynet-3.0/include/numeric.h	Mon Feb  2 01:41:28 2004
@@ -229,7 +229,7 @@
 #define RPL_ENDOFWHOIS       318
 #define RPL_WHOISCHANNELS    319
 /*      RPL_WHOIS_HIDDEN     320         Anothernet +h, ick! */
-/*	RPL_WHOISSPECIAL     320	unreal */
+#define RPL_WHOISSPECIAL     320 /* rain - matching unreal for SSL connections */
 #define RPL_LISTSTART        321
 #define RPL_LIST             322
 #define RPL_LISTEND          323
diff -uNrd ircd-hybrid-7.0/include/patchlevel.h anynet-3.0/include/patchlevel.h
--- ircd-hybrid-7.0/include/patchlevel.h	Wed Jun 11 00:38:40 2003
+++ anynet-3.0/include/patchlevel.h	Mon Feb  2 01:42:23 2004
@@ -23,5 +23,6 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "hybrid-7.0"
+/* rain - updated */
+#define PATCHLEVEL   "hybrid-7.0/anynet-3.0"
 #endif
diff -uNrd ircd-hybrid-7.0/include/s_bsd.h anynet-3.0/include/s_bsd.h
--- ircd-hybrid-7.0/include/s_bsd.h	Sun Jan 19 08:19:50 2003
+++ anynet-3.0/include/s_bsd.h	Thu Jan 22 00:42:45 2004
@@ -80,6 +80,9 @@
 extern int   comm_select(unsigned long);
 extern int   disable_sock_options(int);
 
+/* rain - add prototype */
+extern void  set_no_delay(int fd);
+
 #ifdef USE_SIGIO
 void do_sigio(int);
 void setup_sigio_fd(int);
diff -uNrd ircd-hybrid-7.0/include/s_conf.h anynet-3.0/include/s_conf.h
--- ircd-hybrid-7.0/include/s_conf.h	Sat Feb 15 19:22:21 2003
+++ anynet-3.0/include/s_conf.h	Mon Feb  2 05:23:20 2004
@@ -75,6 +75,7 @@
   struct Class *   c_class;     /* Class of connection */
   struct DNSQuery* dns_query;
   int              aftype;
+  time_t           ts;		/* rain - timestamp (bah.) */
 #ifdef HAVE_LIBCRYPTO
   char *           rsa_public_key_file;
   RSA *            rsa_public_key;
@@ -175,7 +176,8 @@
 
   char *logpath;
   char *operlog;
-  char *glinelog;
+/* rain - no longer relevant */
+/*  char *glinelog; */
 
   char *servlink_path;
   char *egdpool_path;
@@ -294,6 +296,10 @@
   int         specific_ipv4_vhost;
   int         specific_ipv6_vhost;
   struct      sockaddr_in dns_host;
+#ifdef SSL_CLIENT_SUPPORT /* rain - SSL client support */
+  int         ssl_status;
+#endif
+  time_t      gline_ts; /* rain - TS for most recent GLINE activity */
 };
 
 struct admin_info
diff -uNrd ircd-hybrid-7.0/include/s_debug.h anynet-3.0/include/s_debug.h
--- ircd-hybrid-7.0/include/s_debug.h	Fri May 24 19:34:08 2002
+++ anynet-3.0/include/s_debug.h	Thu Jan 22 14:08:35 2004
@@ -46,7 +46,11 @@
 extern void send_usage(struct Client*);
 extern void count_memory (struct Client *);
 
+#ifdef __GNUC__ /* rain - __attribute__ format to catch nasties */
+extern void debug(int, char *, ...) __attribute__((format(printf, 2, 3)));
+#else
 extern void debug(int, char *, ...);
+#endif
 
 #endif /* INCLUDED_s_debug_h */
 
diff -uNrd ircd-hybrid-7.0/include/s_log.h anynet-3.0/include/s_log.h
--- ircd-hybrid-7.0/include/s_log.h	Fri Sep  6 15:37:10 2002
+++ anynet-3.0/include/s_log.h	Thu Jan 22 14:09:34 2004
@@ -39,7 +39,12 @@
 extern void reopen_log(const char* filename);
 extern void set_log_level(int level);
 extern int  get_log_level(void);
+#ifdef __GNUC__ /* rain - __attribute__ format to catch nasties */
+extern void ilog(int priority, const char* fmt, ...)
+    __attribute__((format(printf, 2, 3)));
+#else
 extern void ilog(int priority, const char* fmt, ...);
+#endif
 extern const char *get_log_level_as_string(int level);
 
 extern void log_user_exit(struct Client *);
